//              ________________________________
//             /                               /
//            /         Slayer_Leader v1      /
//           /          HellsHero  1786      /
//          /_______________________________/
//      __ __    __  __      ____      __  __
//     / // /   / / / /___  / / /_____/ / / /___  _________
//    / // /   / /_/ // _ \/ / // ___/ /_/ // _ \/ ___/ __ \
//   / // /   / __  //  __/ / /(__  ) __  //  __/ /  / /_/ /
//  /_//_/   /_/ /_/ \___/_/_//____/_/ /_/ \___/_/   \____/

//bugs:
//Unknown error, if you manually switch people around and don't reset the minigame, something may mess up and a team may not have a leader.

if(!$Slayer::Server::Dependencies::Gamemodes)
	exec("Add-ons/Gamemode_Slayer/Dependencies/Gamemode.cs");
Slayer.Gamemodes.addMode("Leader","LDR",1,1);

if(!$Slayer::Server::Dependencies::Preferences)
	exec("Add-ons/Gamemode_Slayer/Dependencies/Preferences.cs");
Slayer.Prefs.addPref("LDR","Leader Kill","%mini.leaderPoints","int -999 999",1,0,1,-1,"Rules LDR Points");
Slayer.Prefs.addPref("LDR","End Round on Leader Death","%mini.leaderDeath","bool",0,1,1,-1,"Rules LDR Mode");
Slayer.Prefs.addPref("LDR","Only team 1 has a Leader","%mini.oneLeader","bool",0,1,1,-1,"Rules LDR Mode");
Slayer.Prefs.addPref("LDR","Leader has a Flag","%mini.leaderFlag","bool",1,1,1,-1,"Rules LDR Mode");
Slayer.Prefs.addPref("LDR","Display who the leader(s) are to","%mini.tellLeader","list" TAB "0 Nobody" TAB "1 Everybody" TAB "2 Their own team",1,0,1,1,"Rules LDR Mode");
if($Slayer::LDR::enableFlags)
    exec("./Flags/ctf.cs");

$Slayer::LDR::Debug = 0; //Just makes it do 'tons' of echos

function Slayer_LDR_NewLeader(%mini,%client,%team)
{
    if($Slayer::LDR::Debug)
        echo("Slayer_LDR_NewLeader( " @ %mini @ " , " @ %client @ " , " @ %team @ " ) called , numMembers = " @ %team.numMembers);
    %team.leader = "";
	%list = "";
	if(%client !$= "")
		for(%i=0;%i < %team.numMembers; %i++)
		{
		    if($Slayer::LDR::Debug)
			    echo("    --> oldLeader = " @ %client);
			%cl = %team.member[%i];
			if($Slayer::LDR::Debug)
			    echo("    --> possible Leader = " @ %cl);
			if(%cl !$= %client && %client.dead() == %cl.dead())
				%list = %list SPC %i;
		}
    if($Slayer::LDR::Debug)
        echo("    --> %list = " @ %list);
	if(%list $= "")
		%rand = getRandom(0,%team.numMembers-1); //chooses leader, but crudely
	else
		%rand = getWord(%list,getRandom(0,getWordCount(%list)-1)); //chooses leader, with a list! (This only happens mid-game)
	%c = %team.member[%rand];
	%team.leader = %c;
	if($Slayer::LDR::Debug)
    	echo("    --> new Leader = " @ %team.leader);
	$slayer::ldr::leaders++;
	if(%mini.oneLeader)
		$slayer::ldr::reset = 0;
    if($slayer::ldr::leaders == %mini.teams.getCount())
		$slayer::ldr::reset = 0;
    if($Slayer::LDR::Debug)
   	    echo("    --> $Slayer:ldr:reset =  " @ $slayer::ldr::reset);
	if(!isObject(%team.leader))
	{
		error("Slayer_LDR_NewLeader(" SPC %mini SPC "," SPC %client SPC "," SPC %team SPC ") : Leader does not exist");
		return -1;
	}
	if(%mini.tellLeader == 1)
	    %mini.messageAll('',"\c3" @ %team.leader.getPlayerName() @ " \c5is the leader for " @ %team.getColorHex() @ %team.name);
	else if(%mini.tellLeader > 1)
		%team.messageAll('',"\c3" @ %team.leader.getPlayerName() @ " \c5is the leader of your " @ %team.getColorHex() @ "team");
	setLdrFlag(%team,((%mini.leaderFlag) ? 1 : 0));
	return %team.leader;
}

function Slayer_LDR_preReset(%mini,%client) //Remove leaders
{
   if($Slayer::LDR::Debug)
	   echo("Slayer_LDR_preReset( " @ %mini @ " , " @ %client @ " ) called");
	$slayer::ldr::reset = 1;
	$slayer::ldr::leaders = 0;
	for(%i=0;%i<%mini.teams.getCount();%i++)
	{
		%t=%mini.teams.getObject(%i);
		%t.leader = "";
	}
}

function Slayer_LDR_Teams_onLeave(%mini,%team,%client) //If leader, change leader to another living player
{
    if($Slayer::LDR::Debug)
        echo("Slayer_LDR_Teams_onLeave( " @ %mini @ " , " @ %team @ " , " @ %client @ " ) called , $slayer::ldr::reset = " @ $slayer::ldr::reset);
    if($slayer::ldr::reset)
        return;
    if(%client == %team.leader)
    {
        if($slayer::ldr::reset)
            return;
        $slayer::ldr::leaders--;
        %living = Slayer_LDR_getLiving(%mini,%team);
        if(%team.numMembers <= 1 || %living <= 1) //there are no people, potentially end round
        {
            if($Slayer::LDR::Debug)
                echo("    --> Ending round because " @ ((%team.numMembers) ? "everyone was dead" : %team @ " is empty"));
            %count = 0;
            %teamCount = %mini.teams.getCount();
            for(%i=0;%i<%teamCount;%i++)
            {
                if(Slayer_LDR_getLiving(%mini,%loopTeam = %mini.teams.getObject(%i)) && %loopTeam != %team)
                {
                    %count++;
                    %winner = %loopTeam;
                }
            }
            if(%count == 1)
                %mini.endRound(%winner);
            else
                %mini.endRound(-1);
        }
        else
        {
            if($Slayer::LDR::Debug)
                echo("    --> Choosing new leader for " @ %team);
            if(%mini.oneLeader && %team == %mini.teams.getObject(0))
                schedule(1,0,Slayer_LDR_NewLeader,%mini,%client,%team);
            else if(!%mini.oneLeader)
                schedule(1,0,Slayer_LDR_NewLeader,%mini,%client,%team);
        }
    }
}

function Slayer_LDR_Teams_onJoin(%mini,%team,%client) //join, check if there is a leader (no? make one.) (yes? make sure he's on the right team (yes? k.) (no? make a new leader))
{
    if($Slayer::LDR::Debug)
        echo("Slayer_LDR_Teams_onJoin( " @ %mini @ " , " @ %team @ " , " @ %client @ " ) called");
    if($slayer::ldr::reset)
        return;
    if(isObject(%leader = %team.leader))
    {
        if($Slayer::LDR::Debug)
            echo("    --> %leader = " @ %leader @ " , %leader.slyrTeam = " @ %leader.slyrTeam);
        if(%leader.slyrTeam != %team)
        {
            $slayer::ldr::leaders--;
            Slayer_LDR_NewLeader(%mini,"",%team);
        }
    }
    else
        Slayer_LDR_NewLeader(%mini,"",%team);
}

function Slayer_LDR_preDeath(%mini,%client,%obj,%killer,%type,%area) //Set if leader is dead, when players die when leader is dead make them dead
{
   if($Slayer::LDR::Debug)
      echo("Slayer_LDR_preDeath( " @ %mini @ " , " @ %client  @ " , " @ %obj @ " , " @ %killer @ " , " @ %type @ " , " @ %area @ " ) called");
	%team = %client.getTeam();
	if(%team != %mini.teams.getObject(0) && %mini.oneLeader)
		return;
	if(%team.leader == %client)
	{
		if(isObject(%killer) && %killer != %client)
		{
			%killer.incScore(%mini.leaderPoints);
			%killer.incScore(-%mini.points_killplayer);
		}
		%client.setDead(1);
		if(!%mini.leaderDeath && Slayer_LDR_getLiving(%mini,%team))
			%mini.messageAll('',%team.getColorHex() @ %team.name @ "\c5 spawning has stopped!");
		//else
			//for(%i=0;%i < %team.numMembers; %i++)
			//{
				//%cl = %team.member[%i];
				//%cl.setDead(1);
			//}
	}
	else
		if(!%mini.leaderDeath && !isObject(%team.leader.player))
			%client.setDead(1);
}

function Slayer_LDR_onSpawn(%mini,%client) // set unique look on leader (AKA FLAG, or etc)
{
   if($Slayer::LDR::Debug)
   {
      echo("Slayer_LDR_onSpawn( " @ %mini @ " , " @ %client @ " ) called");
      echo("    --> # of exisiting leaders = " @ $slayer::ldr::leaders);
   }
	%team = %client.getTeam();
	if(!isObject(%team.leader) && $slayer::ldr::reset)
	{
		if(%mini.oneLeader && %team != %mini.teams.getObject(0))
			return;
		Slayer_LDR_NewLeader(%mini,"",%team);
		if(%mini.leaderFlag)
			schedule(33,0,setLdrFlag,%team,1);
		else
			schedule(33,0,setLdrFlag,%team,0);
	}
	else if(%team.leader == %client)
		if(%mini.leaderFlag)
			schedule(33,0,setLdrFlag,%team,1);
		else
			schedule(33,0,setLdrFlag,%team,0);
}

function Slayer_LDR_onObserverTrigger(%mini,%obj,%cam,%btn,%state,%client) //stuff yo
{
   if($Slayer::LDR::Debug)
      echo("Slayer_LDR_onObserverTrigger( " @ %mini @ " , " @ %obj @ " , " @ %cam @ " , " @ %btn @ " , " @ %state @ " , " @ %client @ " ) called");
	%team = %client.getTeam();
	if(!isObject(%team.leader))
	{
		if(%mini.oneLeader && %team != %mini.teams.getObject(0))
			return;
		error("ERROR: Slayer_LDR_onObserverTrigger - No leader?");
		return;
	}
	if(%team.leader.dead())
	{
		%living = Slayer_LDR_getLiving(%mini,%team,1);
		if($Slayer::LDR::Debug)
		    echo("    --> " @ %team @ ".leader.dead() = true , %living = " @ %living);
		if(%living < 1) //This is here incase something funny happens
		{
            %teamCount = %mini.teams.getCount();
            for(%i=0;%i<%teamCount;%i++)
            {
                %living = Slayer_LDR_getLiving(%mini,%loopTeam = %mini.teams.getObject(%i),1);
                if(%living > 0)
                {
                    %count++;
                    %winner = %loopTeam;
                }
            }
            if(%count == 1)
                %mini.endRound(%winner);
		}
	}
}

function Slayer_LDR_onModeEnd(%mini) //Remove variables from teams
{
   if($Slayer::LDR::Debug)
      echo("Slayer_LDR_onModeEnd( " @ %mini @ " ) called");
	for(%i=0; %i < %mini.teams.getCount(); %i++)
	{
		%t = %mini.teams.getObject(%i);
		%t.leader = "";
	}
}

function Slayer_LDR_onLeave(%mini,%client)
{
   if($Slayer::LDR::Debug)
      echo("Slayer_LDR_onLeave( " @ %mini @ " , " @ %client @ " ) called , numMembers = " @ %client.slyrTeam.numMembers);
	%team = %client.slyrTeam;
	%living = Slayer_LDR_getLiving(%mini,%team,1);
	if(%team.numMembers <= 1 || (%living <= 1 && isObject(%client.player)))
	{
	    %teamCount = %mini.teams.getCount();
	    for(%i=0;%i<%teamCount;%i++)
	    {
	        %l = Slayer_LDR_getLiving(%mini,%t = %mini.teams.getObject(%i));
	        if(%l > 0 && %t != %team)
	        {
	            %count++;
	            %winner = %t;
	        }
	    }
	    if(%count == 1)
	        %mini.endRound(%winner);
        else
            return;
	}
}

function Slayer_LDR_getLiving(%mini,%team,%playerObject)
{
    if($Slayer::LDR::Debug)
        echo("Slayer_LDR_getLiving( " @ %mini @ " , " @ %team @ " ) called");
	for(%i=0; %i < %team.numMembers; %i++)
	{
        if(%playerObject) //Searches for playerObjects instead of lives
            %living = %living + ((%team.member[%i].player) ? 1 : 0);
        else
            %living = %living + ((%team.member[%i].dead()) ? 0 : 1);
	}
    if($Slayer::LDR::Debug)
        echo("    --> %team = " @ %team.name @ " , %living = " @ %living);
	return %living;
}

function Slayer_LDR_victoryCheck_Lives(%this)
{
   if($Slayer::LDR::Debug)
      echo("Slayer_LDR_victoryCheck_Lives( " @ %this @ " ) called");
    %teamCount = %this.teams.getCount();
	if(%this.leaderDeath)
	{
		for(%i=0; %i < %teamCount; %i++)
		{
			%t = %this.teams.getObject(%i);
			%l = %t.leader;
			if(isObject(%l) && !%l.dead())
			{
				%winner = %t;
				%count++;
				if($Slayer::LDR::Debug)
			        echo("    --> isObject( " @ %l @ " ) && !" @ %l @ ".dead() = true , %winner = " @ %winner @ " , %count = " @ %count);
			}
			if(%this.oneLeader && %t != %this.teams.getObject(0) && Slayer_LDR_getLiving(%this,%t))
			{
				%winner = %t;
				%count++;
				if($Slayer::LDR::Debug)
			        echo("    --> " @ %this @ ".oneLeader && " @ %t @ " != " @ %this @ ".teams.getObject(0) && Slayer_LDR_getLiving( " @ %this @ " , " @ %t @ " ) = true , %winner = " @ %winner @ " , %count = " @ %count);
			}
		}
	}
	else
	{
		for(%i=0;%i<%teamCount;%i++)
			if(Slayer_LDR_getLiving(%this,%t = %this.teams.getObject(%i),((%t.leader.dead()) ? 1 : 0)))
			{
				%winner = %t;
				%count++;
				if($Slayer::LDR::Debug)
				    echo("    --> Slayer_LDR_getLiving( " @ %this @ " , " @ %this @ ".teams.getObject( " @ %i @ " , " @ ((%t.leader.dead()) ? 1 : 0) @ " ) = true , %winner = " @ %winner @ " , %count = " @ %count);
			}
	}
	if(%count == 1)
		return %winner;
	else if(%count > 1)
		return -1;
	else
		return 0;
}

function setLdrFlag(%team,%a)
{
   if($Slayer::LDR::Debug)
      echo("setLdrFlag( " @ %team @ " , " @ %a @ " ) called");
	%player = %team.leader.player;
	if(!isObject(%player))
		return;
	if(%a)
	{
        %player.mountImage((($Slayer::LDR::enableFlags) ? "slyrLDR_Flag" : "slyrCTF_Flag") @ %team.color @ "Image",(($Slayer::LDR::enableFlags) ? $Slayer::Server::LDR::flagImageSlot : $Slayer::Server::CTF::flagImageSlot));
        if($Slayer::LDR::Debug)
		   echo("    --> " @ %team @ ".leader = " @ %team.leader @ " , " @ (($Slayer::LDR::enableFlags) ? "slyrLDR_Flag" : "slyrCTF_Flag") @ %team.color @ "Image , " @ (($Slayer::LDR::enableFlags) ? $Slayer::Server::LDR::flagImageSlot : $Slayer::Server::CTF::flagImageSlot));
	}
	else
		if($Slayer::LDR::enableFlags)
			%player.unmountImage($Slayer::Server::LDR::flagImageSlot);
		else
		{
			%player.allowFlagRemoval = 1; //This is something related to the LDR gamemode
			%player.unmountImage($Slayer::Server::CTF::flagImageSlot);
		}
}

function Slayer_LDR_SetFlags(%mini,%a,%e)
{
   if($Slayer::LDR::Debug)
      echo("Slayer_LDR_setFlags( " @ %mini @ " , " @ %a @ " , " @ %e @ " ) called");
	if(%a)
		for(%i=0;%i < %mini.teams.getCount(); %i++)
		{
			%t = %mini.teams.getObject(%i);
			if(%e)
				for(%a=0;%a<%t.numMembers;%a++)
					if(isObject(%p = %t.member[%a].player))
						if(%t.leader.player == %p)
							setLdrFlag(%p,%t,1);
						else
							setLdrFlag(%p,%t,0);
			else
				if(isObject(%p = %t.leader.player))
					setLdrFlag(%p,%t,1);
		}
	else
		for(%i=0;%i < %mini.teams.getCount(); %i++)
		{
			%t = %mini.teams.getObject(%i);
			if(%e)
				for(%a=0;%a<%t.numMembers;%a++)
					if(isObject(%p = %t.member[%a].player))
						setLdrFlag(%p,%t,0);
			else
				if(isObject(%p = %t.leader.player))
					setLdrFlag(%p,%t,0);
		}
}

function serverCmdGetTeamLeaders(%client)
{
    if($Slayer::LDR::Debug)
    {
        echo("ServerCmdGetTeamLeaders( " @ %client @ " ) called");
        %mini = %client.minigame;
        %count = %mini.teams.getCount();
        for(%i=0;%i<%count;%i++)
        {
            %team = %mini.teams.getObject(%i);
            %msg = %team.name SPC %team.leader SPC %team.leader.slyrTeam.name;
            messageClient(%client, '', "\c6" @ %msg);
            echo("    --> " @ %msg);
        }
    }
}

//Events
//----
//

//vars
//----
//<var:cl:leader> (gives 1 if the client is a leader, 0 if not)
//<var:mg:teamLeader[1-6]> (gives the name of the specific team's leader)

//doors
//----
//teamLdrAllow (-1 allows anyone who is not a leader, 0 allows anyone who is a leader, >0 allows specific team's leader)
//teamLdrDeny (-1 denys anyone who is not a leader, 0 denys anyone who is a leader, >0 denys specific team's leader)
package Slayer_LDR_Events
{
    function GameConnection::LDR_getLeader(%this)
    {
        if(isObject(%mini = %this.minigame) && %team = %this.slyrTeam)
        {
            %leader = %team.leader;
            if(%this == %leader)
                return 1;
        }
        return 0;
    }
    function fxDTSBrick::contentLeaderTeamAllowUse(%this,%action,%direction,%text,%client)
	{
		%id = %this.contentTypeID();
		if(%id >= 0)
		{
			%mini = getMinigameFromObject(%this.getGroup());
			if(isSlayerMinigame(%mini))
			{
				if(!miniGameCanUse(%client,%this))
					return 0;
                
				%team = %client.getTeam();
                %leader = %team.leader;
				for(%i=0; %i < getWordCount(%text); %i++) //-1 = any non leader, 0 = any leader, > 0 = leader of that team
				{
					%w = getWord(%text,%i);
                    
                    if(%w==0 && isObject(%team) && %client == %leader)
                        return 1;
                    if(%w==-1 && (%client != %leader || !isObject(%team)))
                        return 1;
                    else if(isObject(%team) && %client == %leader && %team.getGroupID() + 1 == %w)
                        return 1;
				}
				return 0;
			}
			else
			{
				for(%i=0; %i < getWordCount(%text); %i++)
				{
					%w = getWord(%text,%i);
					if(%w == -1)
						return 1;
				}
				return 0;
			}
		}
		else
			return -1;
	}
	function fxDTSBrick::contentLeaderTeamDenyUse(%this,%action,%direction,%text,%client)
	{
		%id = %this.contentTypeID();
		if(%id >= 0)
		{
			%mini = getMinigameFromObject(%this.getGroup());
			if(isSlayerMinigame(%mini))
			{
				if(!miniGameCanUse(%client,%this))
					return 0;
				%team = %client.getTeam();
                %leader = %team.leader;
				for(%i=0; %i < getWordCount(%text); %i++) //-1 = any non leader, 0 = all leaders, > 0 leader of that team
				{
					%w = getWord(%text,%i);
                    
                    if(%w==0 && isObject(%team) && %client == %leader)
                        return 0;
                    if(%w==-1 && (%client != %leader || !isObject(%team)))
                        return 0;
                    else if(isObject(%team) && %client == %leader && %team.getGroupID() + 1 == %w)
                        return 0;
				}
				return 1;
			}
			else
			{
				for(%i=0; %i < getWordCount(%text); %i++)
				{
					%w = getWord(%text,%i);
					if(%w == -1)
						return 0;
				}
				return 1;
			}
		}
		else
			return -1;
	}
    function onMissionLoaded()
	{
		Slayer.schedule(0,createLDRevents);
		return parent::onMissionLoaded();
	}
    function Slayer::createLDRevents(%this)
	{
        if($AddOn__JVS_Content == 1 && isFunction(ContentRestrictionsSO,addRestriction))
        {
            ContentRestrictionsSO.addRestriction("TeamLdrAllow","contentLeaderTeamAllowUse","10100131");
			ContentRestrictionsSO.addRestriction("TeamLdrDeny","contentLeaderTeamDenyUse","10200131");
        }
        if($AddOn__Event_Variables == 1 && isFunction(registerSpecialVar))
		{
            registerSpecialVar(GameConnection,"leader","%this.LDR_getLeader()");
            for(%i=1; %i <= $Slayer::Server::Preload::Teams::maxEvents; %i++)
				registerSpecialVar(MinigameSO,"teamLeader" @ %i,"%this.Teams.getObject(" @ %i - 1 @ ").leader.name");
		}
	}
    
    
};
activatePackage(Slayer_LDR_Events);