//This is all code by Greek2me, just very slightly modified!
//Flag model is made by Taboo for Greek2me's Slayer LDR.

if(!isObject(Slayer.LDRFlags))
{
	Slayer.LDRFlags = new simSet();
	Slayer.add(Slayer.LDRFlags);
}

Slayer.Prefs.addPref("LDR","Flag Type","$Slayer::Server::Preload::LDR::flagType",$flagTypeList,0,0,0,0,"Advanced","",1);
Slayer.Prefs.addNonNetworkedPref("LDR","Max Flag Colors","$Slayer::Server::Preload::LDR::maxFlagColors","int 2 64",10);

$Slayer::Server::LDR::flagModel = $Slayer::Server::Preload::LDR::flagType;

function Slayer_createLDRDBs(%this)
{
	for(%i=0; %i < $Slayer::Server::Preload::LDR::maxFlagColors; %i++)
	{
		%color = getColorIDTable(%i);
		datablock ItemData(flagItem)
		{
			className = slyrLDR_FlagItem;

			shapeFile = $Slayer::Server::LDR::flagShapeFile[$Slayer::Server::LDR::flagModel];
			uiName = "";

			doColorShift = true;
			colorShiftColor = %color;
			colorID = %i;
		};
		flagItem.setName("slyrLDR_Flag" @ %i @ "Item");

		datablock ShapeBaseImageData(flagImage)
		{
			className = slyrLDR_FlagImage;

			shapeFile = $Slayer::Server::LDR::flagShapeFile[$Slayer::Server::LDR::flagModel];
			emap = true;
			mountPoint = $Slayer::Server::LDR::flagMountPoint[$Slayer::Server::LDR::flagModel];
			offset = $Slayer::Server::LDR::flagOffset[$Slayer::Server::LDR::flagModel];
			eyeOffset = "0 0 10";

			rotate = false;
			rotation = $Slayer::Server::LDR::flagRotation[$Slayer::Server::LDR::flagModel];

			armReady = false;

			doColorShift = true;
			colorShiftColor = %color;
			colorID = %i;

			hasLight = $Slayer::Server::LDR::flagHasLight[$Slayer::Server::LDR::flagModel];
			lightType = $Slayer::Server::LDR::flagLightType[$Slayer::Server::LDR::flagModel];
			lightColor = %color;
			lightTime = $Slayer::Server::LDR::flagLightTime[$Slayer::Server::LDR::flagModel];
			lightRadius = $Slayer::Server::LDR::flagLightRadius[$Slayer::Server::LDR::flagModel];

			stateName[0] = $Slayer::Server::LDR::flagStateName[0,$Slayer::Server::LDR::flagModel];
			stateTransitionOnTimeout[0] = $Slayer::Server::LDR::flagStateTransitionOnTimeout[0,$Slayer::Server::LDR::flagModel];
			stateTimeoutValue[0] = $Slayer::Server::LDR::flagStateTimeoutValue[0,$Slayer::Server::LDR::flagModel];
			stateSequence[0] = $Slayer::Server::LDR::flagStateSequence[0,$Slayer::Server::LDR::flagModel];
		};
		flagImage.setName("slyrLDR_Flag" @ %i @ "Image");
	}
}

if(!isObject(flagItem))
	Slayer_createLDRDBs();
	
function slyrLDR_FlagItem::onAdd(%this,%obj)
{
	Slayer.LDRFlags.add(%obj);

	if($Slayer::Server::LDR::flagIdleAnimation[$Slayer::Server::LDR::flagModel] !$= "")
		%obj.playThread(0,$Slayer::Server::LDR::flagIdleAnimation[$Slayer::Server::LDR::flagModel]);
}

function getClosestLDRColor(%rgba)
{
	%prevdist = 100000;
	%colorMatch = 0;
	for(%i=0; %i < $Slayer::Server::LDR::maxFlagColors; %i++)
	{
		%color = getColorIDTable(%i);
		if(vectorDist(%rgba,getWords(%color,0,2)) < %prevdist && getWord(%rgba,3) - getWord(%color,3) < 0.3 && getWord(%rgba,3) - getWord(%color,3) > -0.3)
		{
			%prevdist = vectorDist(%rgba,%color);
			%colormatch = %i;
		}
	}
	return %colormatch;
}